<template>
  <v-page :headerText="headerText">
    <div class="form-pages-container" ref=pagesContainer>

      <v-step-page :show="step === DeviceAuthStep.EDIT_DEVICE" ref="editDevicePage">
        <v-button
            v-show="mode === DeviceEditorMode.EDIT_EXISTING"
            class="button-delete"
            :disabled="inProgress"
            :in-progress="removeInProgress"
            :type="ButtonType.DANGER"
            @click="onDelete"
        >
          Delete
        </v-button>

        <input
            v-show="preset.manufacturerId == null"
            v-model="device.manufacturerId"
            ref="manufacturerIdInput"
            type="text"
            placeholder="Manufacturer Id"
            :disabled="inProgress || removeInProgress"
            @input="onInput"
            @keyup.enter="onSave"
        />

        <input
            v-show="preset.deviceNumber == null"
            v-model="device.deviceNumber"
            ref="deviceNumberInput"
            type="text"
            placeholder="Device number"
            :disabled="inProgress || removeInProgress"
            @input="onInput"
            @keyup.enter="onSave"
        />

        <input
            v-show="preset.tags == null"
            v-model="device.tags"
            type="text" placeholder="Tags"
            :disabled="inProgress || removeInProgress"
            @input="onInput"
            @keyup.enter="onSave"
        />

        <input
            v-show="preset.role == null"
            v-model="device.role"
            ref="roleInput"
            type="text"
            placeholder="Role"
            :disabled="inProgress || removeInProgress"
            @input="onInput"
            @keyup.enter="onSave"
        />

        <input
            v-show="preset.pass == null"
            v-model="device.pass"
            type="password"
            :placeholder="mode === DeviceEditorMode.ADD_NEW ? 'Password' : 'New password'"
            :disabled="inProgress || removeInProgress"
            @input="onInput"
            @keyup.enter="onSave"
        />

        <FormErrorMessage
            class="edit-device-error"
            v-show="step === DeviceAuthStep.EDIT_DEVICE && error"
        >
          {{ error }}
        </FormErrorMessage>

      </v-step-page>

      <v-step-page :show="step === DeviceAuthStep.CHOOSE_NAME" class="choose-name-form" ref="chooseNamePage">
        <input v-model="device.name" type="text" placeholder="Name" ref="nameInput" @keyup.enter="onDone">
        <div class="status-container"><StatusLabel :online="online"/> {{ online ? 'online' : 'offline' }}</div>
        <FormErrorMessage
            v-show="step === DeviceAuthStep.CHOOSE_NAME && error"
            class="error"
        >
          {{ error }}
        </FormErrorMessage>
      </v-step-page>
    </div>

    <div v-show="step === DeviceAuthStep.EDIT_DEVICE">
      <v-button
          :type="ButtonType.SUCCESS"
          :in-progress="inProgress"
          :disabled="removeInProgress"
          @click="onSave">
        Save
      </v-button>
      <br/>
      <v-button-link
          v-show="cancelButton === CancelButton.BACK"
          :disabled="inProgress || removeInProgress"
          to="/choose-device"
      >
        back
      </v-button-link>
      <v-button-link
          v-show="cancelButton === CancelButton.SIGN_OUT"
          :disabled="inProgress || removeInProgress"
          @click="onSignOut"
      >
        sign out
      </v-button-link>
    </div>

    <div v-show="step === DeviceAuthStep.CHOOSE_NAME">
      <v-button
          :type="ButtonType.SUCCESS"
          :in-progress="inProgress"
          @click="onDone"
      >
        Done
      </v-button>
      <br/>
      <v-button-link :disabled="inProgress" negative @click="onCancel">cancel</v-button-link>
    </div>

  </v-page>
</template>

<script>
  import { animate, animateError, ButtonType, StatusLabel, VButton, VButtonLink, VPage } from 'zeus-common'
  import VStepPage from '@/pages/device-editor/component/VStepPage'

  import 'zeus-common/src/component/common.scss'
  import { signOut } from '@/common/auth'
  import { CancelButton, DeviceEditorMode, DeviceEditorStep } from '@/pages/device-editor/component/consts'
  import FormErrorMessage from 'zeus-common/src/component/input/FormErrorMessage'
  import { DeviceEditorError } from '@/pages/device-editor/common'
  import { headerText, preset } from '@/config'

  const mergeDeviceInputWithPreset = (deviceInput, preset) => ({
    manufacturerId: preset.manufacturerId || Number(deviceInput.manufacturerId),
    deviceNumber: preset.deviceNumber || Number(deviceInput.deviceNumber),
    tags: preset.tags || deviceInput.tags.split(/[,\s]+/g).filter(tag => tag),
    role: preset.role || deviceInput.role,
    pass: preset.pass || deviceInput.pass || ''
  })

  export default {
    name: 'DeviceAuthPage',
    components: { FormErrorMessage, VButtonLink, StatusLabel, VButton, VStepPage, VPage },
    props: {
      mode: { type: String, default: DeviceEditorMode.ADD_NEW },
      cancelButton: { type: String, default: CancelButton.BACK },
      online: Boolean,
      step: { type: String, default: DeviceEditorStep.EDIT_DEVICE },
      error: String,
      inProgress: Boolean,
      removeInProgress: { type: Boolean, default: false },
      device: {
        type: Object,
        default: () => ({
          manufacturerId: '',
          deviceNumber: '',
          tags: '',
          role: '',
          pass: '',
          name: ''
        })
      }
    },
    data() { return {
      preset: preset,
      headerText: headerText,
      ButtonType: ButtonType,
      DeviceAuthStep: DeviceEditorStep,
      DeviceEditorMode: DeviceEditorMode,
      CancelButton: CancelButton
    }},
    mounted() {
      setPagesContainerHeight(this.$refs.pagesContainer)
    },
    updated() {
      setPagesContainerHeight(this.$refs.pagesContainer)
    },
    watch: {
      step(step) {
        switch (step) {
          case DeviceEditorStep.CHOOSE_NAME:
            animate(this.$refs.chooseNamePage.$vnode.elm, 'fade-in')
            break

          case DeviceEditorStep.EDIT_DEVICE:
            animate(this.$refs.editDevicePage.$vnode.elm, 'fade-in')
            break
        }
      },
      error(error) {
        switch (error) {
          case DeviceEditorError.MANUFACTURER_ID_IS_NOT_NUMBER:
          case DeviceEditorError.NO_SUCH_MANUFACTURER:
            animateError(this.$refs.manufacturerIdInput)
            break
          case DeviceEditorError.DEVICE_NUMBER_IS_NOT_NUMBER:
            animateError(this.$refs.deviceNumberInput)
            break
        }
      }
    },
    methods: {
      onInput() {
        this.$emit('input')
      },
      onSave() {
        let errorCounter = 0

        if (!this.device.manufacturerId && this.preset.manufacturerId == null) {
          animateError(this.$refs.manufacturerIdInput)
          errorCounter++
        }
        if (!this.device.deviceNumber && this.preset.deviceNumber == null) {
          animateError(this.$refs.deviceNumberInput)
          errorCounter++
        }
        if (!this.device.role && !this.preset.role) {
          animateError(this.$refs.roleInput)
          errorCounter++
        }

        if (errorCounter === 0) {
          this.$emit('save', mergeDeviceInputWithPreset(this.device, this.preset))
        }
      },
      onDone() {
        if (this.device.name) {
          this.$emit('done', {
            ...mergeDeviceInputWithPreset(this.device, this.preset),
            name: this.device.name
          })
        } else {
          animateError(this.$refs.nameInput)
        }
      },
      onCancel() {
        this.$emit('cancel')
      },
      onDelete() {
        this.$emit('delete')
      },
      onSignOut: signOut
    }
  }

  function setPagesContainerHeight(element) {
    const maxHeight = Array.from((element).children)
      .map(child => child.clientHeight)
      .reduce((max, current) => max > current ? max : current);

    element.style.height = maxHeight + "px";
  }
</script>

<style scoped lang="scss">
  .form-pages-container {
    position: relative;

    .edit-device-error {
      margin-top: 0.25em;
      margin-bottom: 0.85em;
    }

    .choose-name-form {
      padding-bottom: 0.8em;

      .error {
        margin-top: 1.2em;
      }
    }
  }

  .status-container {
    margin-top: 0.4em;
  }

  .button-delete {
    margin-top: 0;
    margin-bottom: 2.4em;
  }
</style>